using Windows.Foundation.Metadata;

using Microsoft.UI;
using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Media;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  Spring2018   - Spring2018

        /// <summary>
        ///  Spring2018  
        /// </summary>
        public bool Spring2018
        {
            get
            {
                return ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 6);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            if(Spring2018 && Application.Current.FocusVisualKind == FocusVisualKind.Reveal)
            {
                this.revealFocusRadioButton.IsChecked      = true;
                this.primaryColorPickerButton.Background   = new SolidColorBrush(primaryColorPicker.Color);
                this.primaryColorPicker.Color              = (Resources["SystemControlRevealFocusVisualBrush"] as SolidColorBrush).Color;
                this.secondaryColorPickerButton.Background = new SolidColorBrush(secondaryColorPicker.Color);
                this.secondaryColorPicker.Color            = (Resources["SystemControlFocusVisualSecondaryBrush"] as SolidColorBrush).Color;
            }
            else
            {
                this.highVisibilityRadioButton.IsChecked   = true;
                this.primaryColorPickerButton.Background   = new SolidColorBrush(this.primaryColorPicker.Color);
                this.secondaryColorPickerButton.Background = new SolidColorBrush(this.secondaryColorPicker.Color);
            }

            ActualThemeChanged                         += Page_ActualThemeChanged;
            this.resetMarginButton.Click               += resetMarginButton_Click;
            this.primaryColorPickerCloseButton.Click   += colorPickerCloseButton_Click;
            this.secondaryColorPickerCloseButton.Click += colorPickerCloseButton_Click;
            this.highVisibilityRadioButton.Checked     += highVisibilityRadioButton_Checked;
            this.revealFocusRadioButton.Checked        += revealFocusRadioButton_Checked;
            this.moveKeyboardFocusButton.Click         += moveKeyboardFocusButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region   ׸  óϱ - Page_ActualThemeChanged(sender, e)

        /// <summary>
        ///   ׸  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Page_ActualThemeChanged(FrameworkElement sender, object e)
        {
            if(ActualTheme == ElementTheme.Light)
            {
                this.primaryColorPicker.Color   = Colors.Black;
                this.secondaryColorPicker.Color = Colors.White;
            }
            else if(ActualTheme == ElementTheme.Dark)
            {
                this.primaryColorPicker.Color   = Colors.White;
                this.secondaryColorPicker.Color = Colors.Black;
            }
        }

        #endregion
        #region  ý Close ư Ŭ óϱ - colorPickerCloseButton_Click(sender, e)

        /// <summary>
        ///  ý Close ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void colorPickerCloseButton_Click(object sender, RoutedEventArgs e)
        {
            this.primaryColorPickerButton.Background   = new SolidColorBrush(this.primaryColorPicker.Color  );
            this.secondaryColorPickerButton.Background = new SolidColorBrush(this.secondaryColorPicker.Color);

            this.primaryColorPickerButton.Flyout.Hide();
            this.secondaryColorPickerButton.Flyout.Hide();
        }

        #endregion
        #region High Visibility  ư üũ óϱ - highVisibilityRadioButton_Checked(sender, e)

        /// <summary>
        /// High Visibility  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void highVisibilityRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if(this.button1.ActualTheme == ElementTheme.Light)
            {
                this.primaryColorPicker.Color   = Colors.Black;
                this.secondaryColorPicker.Color = Colors.White;
            }
            else if(this.button1.ActualTheme == ElementTheme.Dark)
            {
                this.primaryColorPicker.Color   = Colors.White;
                this.secondaryColorPicker.Color = Colors.Black;
            }

            this.primaryColorPickerButton.Background = new SolidColorBrush(this.primaryColorPicker.Color);

            Application.Current.FocusVisualKind = FocusVisualKind.HighVisibility;
        }

        #endregion
        #region Reveal Focus  ư üũ óϱ - revealFocusRadioButton_Checked(sender, e)

        /// <summary>
        /// Reveal Focus  ư üũ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void revealFocusRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            if(Spring2018)
            {
                this.primaryColorPicker.Color = (Resources["SystemControlRevealFocusVisualBrush"] as SolidColorBrush).Color;

                this.primaryColorPickerButton.Background = new SolidColorBrush(primaryColorPicker.Color);

                Application.Current.FocusVisualKind = FocusVisualKind.Reveal;
            }
        }

        #endregion
        #region Reset Margin ư Ŭ óϱ - resetMarginButton_Click(sender, e)

        /// <summary>
        /// Reset Margin ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void resetMarginButton_Click(object sender, RoutedEventArgs e)
        {
            this.marginSlider.Value = -1 * (this.primarySlider.Value + this.secondarySlider.Value);
        }

        #endregion
        #region Move Keyboard Focus ư Ŭ óϱ - moveKeyboardFocusButton_Click(sender, e)

        /// <summary>
        /// Move Keyboard Focus ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void moveKeyboardFocusButton_Click(object sender, RoutedEventArgs e)
        {
            this.button1.Focus(FocusState.Keyboard);
        }

        #endregion
    }
}